CREATE TABLE user (
  id BIGINT NOT NULL AUTO_INCREMENT PRIMARY KEY,
  name VARCHAR(255) NOT NULL,
  email VARCHAR(255) NOT NULL,
  password_hash VARCHAR(255) NOT NULL,
  password_salt VARCHAR(255) NOT NULL
);

CREATE TABLE question (
  id BIGINT NOT NULL AUTO_INCREMENT PRIMARY KEY,
  text TEXT DEFAULT 'Null' NULL,
  user_id BIGINT NOT NULL,
  CONSTRAINT q_user_fk FOREIGN KEY (user_id) REFERENCES user (id)
);

ALTER TABLE question
  ADD COLUMN doc_key VARCHAR(255) NULL;

ALTER TABLE question
  ADD COLUMN doc_name VARCHAR(255) NULL,
  ADD COLUMN doc_type VARCHAR(255) NULL;

ALTER TABLE question
  ADD text_format TEXT DEFAULT 'Null' NULL,
  ADD title VARCHAR (255)
;


CREATE TABLE answer (
  id BIGINT NOT NULL AUTO_INCREMENT PRIMARY KEY,
  text TEXT DEFAULT 'Null' NULL,
  user_id BIGINT NOT NULL,
  question_id BIGINT NOT NULL,
  CONSTRAINT a_user_fk FOREIGN KEY (user_id) REFERENCES user (id),
  CONSTRAINT a_question_fk FOREIGN KEY (question_id) REFERENCES question (id)
    ON DELETE CASCADE
);

CREATE TABLE question_comment (
  id          BIGINT              NOT NULL AUTO_INCREMENT PRIMARY KEY,
  text        TEXT DEFAULT 'Null' NULL,
  user_id     BIGINT              NOT NULL,
  question_id BIGINT              NOT NULL,
  CONSTRAINT qc_user_fk FOREIGN KEY (user_id) REFERENCES user (id),
  CONSTRAINT qc_question_fk FOREIGN KEY (question_id) REFERENCES question (id)
    ON DELETE CASCADE
);

CREATE TABLE answer_comment (
  id          BIGINT              NOT NULL AUTO_INCREMENT PRIMARY KEY,
  text        TEXT DEFAULT 'Null' NULL,
  user_id     BIGINT              NOT NULL,
  answer_id BIGINT              NOT NULL,
  CONSTRAINT ac_user_fk FOREIGN KEY (user_id) REFERENCES user (id),
  CONSTRAINT ac_answer_fk FOREIGN KEY (answer_id) REFERENCES answer (id)
    ON DELETE CASCADE
);