**Deployment**\
**Preparing the environment**\
**Installing Maven**\
To build the project, it is necessary to have Maven version 3.3.9 installed. To do so, we just need to open a terminal and use the following commands:\
`$ apt-get -y install maven`

**Installing Node**\
We will use Node.js to run Javascript on the server. We also install npm (node package manager). The installed version was the stable versions at the time, 8.10 and 5.6 respectively.\
`$ sudo apt-get install nodejs`\
`$ sudo apt-get install npm`

Before that, we may need to update our local repositories\
`$ sudo apt-get update`

**Installing Gulp**\
Once Node is install, we use npm to install gulp\
`$ sudo npm install --global gulp`

**Starting databases**\
**MariaDB**

We need to install our MariaDB server and client, version 10.2.13.\
`$ sudo apt-get install mariadb-server mariadb-client`

Start running it\
`$ sudo systemctl start mysql`

Add the database structure with its tables, we do the following:\
`$ mysql -u [username] -p[password]`

Create the database.\
`$ CREATE DATABASE sharecare;`

**Redis**\
Redis provides in its website the commands to download it and compile it really easily. We will use Redis 4.0.9.\
`$ wget http://download.redis.io/redis-stable.tar.gz`\
`$ tar xvzf redis-stable.tar.gz`\
`$ cd redis-stable`\
`$ make`

Start the server.\
`$ redis-server`

**ElasticSearch**

Similar to Redis, we need to download ElasticSearch and run the server in our machine. We just need to follow the instructions in the ElasticSearch website to get the version 6.2.4.\
Download ElasticSearch\
`$ curl -L -O https://artifacts.elastic.co/downloads/elasticsearch/elasticsearch-6.2.4.tar.gz`

Extract the tar\
`tar -xvf elasticsearch-6.2.4.tar.gz`

Start ElasticSearch\
`$ ./elasticsearch`


**Amazon Web Services S3**

In order to use AWS S3, it is necessary to create an account in https://aws.amazon.com/. Once the account is created, we need to go to IAM (Identity and Access Management) to create a user. This user is what we will use to connect our application to AWS S3. Here, we need to create the user, select the option programmatic access to allow the connection through an access key and a secret key, and then we will give it the permission “AmazonS3FullAccess”.

After creating this user, we need to go to S3, under the tag Services, and create a bucket. A bucket is the specific storage where our information will be stored.

Now, we just need to use the Java API provided to access the storage, using both keys and the bucket name.

**Starting ShareCare for the first time**
**Creating JAR**

First, we need to download the project from the GitHub repository, either downloading the zip or using git clone.\
Downloading zip\
`https://github.com/yockiehub/sharecare/archive/master.zip`

Cloning project\
`$ git clone https://github.com/yockiehub/sharecare.git`

After downloading and extracting the files, we need to build the project, generating the JAR file. To do that, we need to run the following command:

Building the project\
`$ mvn package`

Executing JAR\
`$ java -jar target/sharecare-platform-webapp-0.0.1.jar`

Execute JAR with AWS S3 keys\
`$ java -jar target/sharecare-platform-webapp-0.0.1.jar --aws.key=[ACCESS_KEY] –aws.secret=[SECRET_KEY]`

**Creating data structure for MariaDB and ElasticSearch**

Adding tables to MariaDB\
`$ mysql -u [username] -p[password] sharecare < migration_1.sql`

As for ElasticSearch, once it is up and running we need to create the index and the text analyzer for the full text searches. For that purpose, there is a file called “ESmapping” within the project. We just need to copy and paste its content in a terminal. After that, everything is ready to start using ShareCare.
