package com.sharecare.config;

import org.elasticsearch.client.Client;
import org.elasticsearch.common.settings.Settings;
import org.elasticsearch.common.transport.TransportAddress;
import org.elasticsearch.transport.client.PreBuiltTransportClient;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.io.IOException;
import java.net.InetAddress;

/**
 * ElasticSearch configuration class
 *
 * Connects to the node host in the port 9300.
 */
@Configuration
public class ElasticSearchConfig {

    private static Logger logger = LoggerFactory.getLogger(ElasticSearchConfig.class);

    @Bean
    public Client client() {
        try {

            return new PreBuiltTransportClient(Settings.EMPTY)
                    .addTransportAddress(new TransportAddress(InetAddress.getByName("localhost"), 9300));


            // @formatter:on
        } catch (final IOException ioex) {
            logger.error("Cannot create temp dir", ioex);
            throw new RuntimeException();
        }
    }

}
