package com.sharecare.core;

import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

/**
 * Service class to deal with the creation of questions and answers and
 * insert them into MariaDB
 *
 */
@Service
@RequiredArgsConstructor
public class PostService {

    private final QuestionRepository questionRepository;
    private final AnswerRepository answerRepository;

    public Question createQuestion(String title, String body, String unformattedBody, String docKey, String docType, String docName, User user) {

        Question q = new Question();
        q.setTitle(title);
        q.setText(unformattedBody);
        q.setTextFormat(body);
        q.setDocKey(docKey);
        q.setDocType(docType);
        q.setDocName(docName);
        q.setUser(user);
        questionRepository.save(q);

        return q;
    }

    public void deleteQuestion(Question question) {
        questionRepository.delete(question);

    }

    public Answer createAnswer(String answer, String bodyUnformatted, User user, long questionId) {

        Question q = questionRepository.findOne(questionId);
        Answer a = new Answer();
        a.setText(bodyUnformatted);
        a.setQuestion(q);
        a.setUser(user);
        answerRepository.save(a);

        return a;
    }
}
