package com.sharecare.core;

import com.sharecare.core.searchable.SearchableEntity;
import lombok.Getter;
import lombok.Setter;
import org.springframework.stereotype.Component;

import javax.persistence.*;
import java.util.List;

@Component
@Getter
@Setter
@Entity
@Table(name = "question")
public class Question implements SearchableEntity, WithTitleEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @ManyToOne
    @JoinColumn(name="user_id", nullable = false)
    private User user;

    @Column(name="text")
    private String text;

    @Column(name="text_format")
    private String textFormat;

    @Column(name="title")
    private String title;

    @Column(name="doc_key")
    private String docKey;

    @Column(name="doc_type")
    private String docType;

    @Column(name="doc_name")
    private String docName;

    @OneToMany(mappedBy = "question")
    private List<Answer> answers;

    @OneToMany(mappedBy = "question")
    private List<QuestionComment> questionCommentList;


}
