package com.sharecare.core;

import com.sharecare.core.searchable.SearchableEntity;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@Entity
@Table(name = "question_comment")
public class QuestionComment implements SearchableEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @ManyToOne
    @JoinColumn(name="user_id", nullable = false)
    private User user;

    @ManyToOne
    @JoinColumn(name="question_id", nullable = false)
    private Question question;

    @Column(name="text")
    private String text;

}
