package com.sharecare.core;

import com.sharecare.core.searchable.SearchableEntity;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.util.List;


@Getter
@Setter
@Entity
@Table(name = "user")
public class User implements SearchableEntity, WithTitleEntity {

    @Id
    @GeneratedValue(strategy= GenerationType.AUTO)
    private Long id;

    @Column(name = "name", nullable = false)
    private String name;

    @Column(name = "email", nullable = false)
    private String email;

    @Column(name = "password_hash", nullable = false)
    private String passwordHash;

    /*@Column(name = "bio", nullable = false)
    private String bio;*/

    @Column(name = "password_salt", nullable = false)
    private String passwordSalt;

    @OneToMany(mappedBy = "user")
    private List<Question> questions;

    @OneToMany(mappedBy = "user")
    private List<QuestionComment> questionCommentList;

    @OneToMany(mappedBy = "user")
    private List<AnswerComment> answerCommentList;


    @Override
    public String getText() {
        return getEmail();
    }

    @Override
    public String getTitle() {
        return getName();
    }
}
