package com.sharecare.core;

import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import redis.clients.jedis.Jedis;

/**
 * Service to store the view count of every question in Redis
 */
@Service
@RequiredArgsConstructor
public class ViewCountService {

    private final Jedis jedis;

    public void createViewCountFor(Question question) {
        jedis.set(getKey(question), "0");
    }

    public void incrViewCountFor(Question question) {
        jedis.incr(getKey(question));
    }

    public long getViewCount(Question question) {
        return Long.valueOf(jedis.get(getKey(question)));
    }

    private String getKey(Question question) {
        return REDIS_NAMESPACE + question.getId();
    }

    private static final String REDIS_NAMESPACE = "viewcount:";
}
