package com.sharecare.core.like;

import lombok.Getter;
import lombok.RequiredArgsConstructor;

import java.util.Optional;

/**
 * Enum to make vote more intelligible
 */
@Getter
@RequiredArgsConstructor
public enum Vote {
    LIKE("like"),
    DISLIKE("dislike");

    private final String stringValue;

    static Optional<Vote> fromIntegerString(String integerValue) {
        if (LIKE.getStringValue().equals(integerValue)) {
            return Optional.of(LIKE);
        }
        if (DISLIKE.getStringValue().equals(integerValue)) {
            return Optional.of(DISLIKE);
        }
        return Optional.empty();
    }

    public boolean isLike() {
        return this.equals(LIKE);
    }

    public boolean isDislike() {
        return this.equals(DISLIKE);
    }
}
