'use strict';

var gulp = require('gulp');
var sass = require('gulp-sass');
const clean = require('gulp-clean');
const sourcemaps = require('gulp-sourcemaps');
//const watch = require('gulp-watch');
const autoprefixer = require('autoprefixer');
const postcss      = require('gulp-postcss');
//const postcssNormalize = require('postcss-normalize');
const cssnano = require('gulp-cssnano');
const scssSrcDir = './src/main/resources/static/scss';
const scssDistDir = './src/main/resources/static/css';
const mainScss = scssSrcDir + '/style.scss';

gulp.task('sass', function () {
    return gulp.src('./sass/**/*.scss')
        .pipe(sass().on('error', sass.logError))
        .pipe(gulp.dest('./css'));
});

gulp.task('sass:watch', function () {
    gulp.watch('./sass/**/*.scss', ['sass']);
});


/* SCSS */

gulp.task('scss-clean', function () {
    return gulp.src(scssDistDir)
        .pipe(clean());
});

gulp.task('scss-compile', [ 'scss-clean' ], function () {
    return gulp.src(mainScss)
        .pipe(sourcemaps.init())
        .pipe(sass().on('error', sass.logError))
        .pipe(postcss([
            //postcssNormalize(),
            autoprefixer()
        ]))
        .pipe(cssnano())
        .pipe(sourcemaps.write('./'))
        .pipe(gulp.dest(scssDistDir));
});
gulp.task('scss', ['scss-compile']);

gulp.task('default', ['scss']);