package com.sharecare.webapp.mvc;


import com.sharecare.core.User;
import com.sharecare.core.UserRepository;
import com.sharecare.webapp.service.UserSessionService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import java.util.Optional;

@Controller
@RequestMapping
@RequiredArgsConstructor
public class HomeController {

    private final UserSessionService userSessionService;

    private final UserRepository userRepository;

    @GetMapping("/")
    public String getHome() {

        return "redirect:/login";
    }

    @GetMapping("/login")
    public String getLogin() {
        Optional<User> userOptional = userSessionService.sessionUser();
        if (userOptional.isPresent()) {
            return "redirect:/app";
        }

        return "login";
    }

    @GetMapping("/signup")
    public String getRegister() {

        return "signup";
    }
}
