package com.sharecare.webapp.mvc;

import com.sharecare.core.User;
import com.sharecare.core.UserRepository;
import com.sharecare.core.UserService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;


@Controller
@RequiredArgsConstructor
@RequestMapping("/join")
public class JoinController {

    private final UserService userService;
    private final UserRepository userRepository;

    @PostMapping
    public String signUp(@RequestParam("name") String name,
                          @RequestParam("email") String email,
                          @RequestParam("password") String password) {

        if (userRepository.findByEmail(email) != null) {
            return "home";
        }

        userService.createUser(name, email, password);

        return "redirect:/app";
    }
}
