package com.sharecare.webapp.service;

import com.sharecare.core.Question;
import com.sharecare.core.QuestionRepository;
import com.sharecare.core.User;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Optional;

@Component
@RequiredArgsConstructor
public class AccountInterceptor extends HandlerInterceptorAdapter{

    private final UserSessionService userSessionService;
    private final QuestionRepository questionRepository;

    @Override
    public void postHandle(HttpServletRequest request, HttpServletResponse response, Object handler,
            ModelAndView modelAndView) throws Exception {

        userSessionService.sessionUser()
                .ifPresent(u -> addModelAttributes(modelAndView, u));
        super.postHandle(request, response, handler, modelAndView);

    }

    private void addModelAttributes(ModelAndView modelAndView, User user) {
        if (modelAndView != null && modelAndView.getModel() != null) {
            modelAndView.addObject("user", user);
            List<Question> allQuestions = questionRepository.findAll();
            modelAndView.addObject("allQuestions", allQuestions);
        }
    }
}
